// Source: https://github.com/solidjs/solid-start/blob/main/packages/create-solid/cli/index.js#L62
export const pnpmRc = function () {
  return `# Workaround for PNPM until: https://github.com/vitejs/vite/pull/9763
# Related: https://github.com/withastro/astro/pull/7034
shamefully-hoist=true
`;
};

export const sleep = function (seconds = 0) {
  return new Promise((res) => setTimeout(res, seconds * 1000));
};

export const getEnvPkgManager = function () {
  // This environment variable is set by npm and yarn but pnpm seems less consistent
  const userAgent = process.env.npm_config_user_agent;

  if (userAgent) {
    if (userAgent.startsWith("yarn")) {
      return "yarn";
    } else if (userAgent.startsWith("pnpm")) {
      return "pnpm";
    } else if (userAgent.startsWith("bun")) {
      return "bun";
    } else {
      return "npm";
    }
  } else {
    // If no user agent is set, assume npm
    return "npm";
  }
};
