import { Component, JSX } from "solid-js";

// https://tabler-icons.io/
// https://icones.js.org/collection/tabler?s=blub
// unplugin-icons Example:
// import HandMoveIcon from "~icons/tabler/hand-move";

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const PencilIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-pencil"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M4 20h4l10.5 -10.5a1.5 1.5 0 0 0 -4 -4l-10.5 10.5v4"></path>
        <path d="M13.5 6.5l4 4"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const CursorTextIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        {...p}
      >
        <path
          fill="none"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
          d="M10 12h4M9 4a3 3 0 0 1 3 3v10a3 3 0 0 1-3 3m6-16a3 3 0 0 0-3 3v10a3 3 0 0 0 3 3"
        />
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const ClickIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        {...p}
      >
        <path
          fill="none"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
          d="M3 12h3m6-9v3M7.8 7.8L5.6 5.6m10.6 2.2l2.2-2.2M7.8 16.2l-2.2 2.2M12 12l9 3l-4 2l-2 4l-3-9"
        />
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const ArrowsMoveIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-arrows-move"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none" />
        <path d="M18 9l3 3l-3 3" />
        <path d="M15 12h6" />
        <path d="M6 9l-3 3l3 3" />
        <path d="M3 12h6" />
        <path d="M9 18l3 3l3 -3" />
        <path d="M12 15v6" />
        <path d="M15 6l-3 -3l-3 3" />
        <path d="M12 3v6" />
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const TrashIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        {...p}
      >
        <path
          fill="none"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
          d="M4 7h16m-10 4v6m4-6v6M5 7l1 12a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2l1-12M9 7V4a1 1 0 0 1 1-1h4a1 1 0 0 1 1 1v3"
        />
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const LoaderIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        {...p}
      >
        <g
          fill="none"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
        >
          <path d="M3 12a9 9 0 0 0 9 9a9 9 0 0 0 9-9a9 9 0 0 0-9-9" />
          <path d="M17 12a5 5 0 1 0-5 5" />
        </g>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const SaveIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-device-floppy"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M6 4h10l4 4v10a2 2 0 0 1 -2 2h-12a2 2 0 0 1 -2 -2v-12a2 2 0 0 1 2 -2"></path>
        <path d="M12 14m-2 0a2 2 0 1 0 4 0a2 2 0 1 0 -4 0"></path>
        <path d="M14 4l0 4l-6 0l0 -4"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const PublishIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-send"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M10 14l11 -11"></path>
        <path d="M21 3l-6.5 18a.55 .55 0 0 1 -1 0l-3.5 -7l-7 -3.5a.55 .55 0 0 1 0 -1l18 -6.5"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const DashboardIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-home-2"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M5 12l-2 0l9 -9l9 9l-2 0"></path>
        <path d="M5 12v7a2 2 0 0 0 2 2h10a2 2 0 0 0 2 -2v-7"></path>
        <path d="M10 12h4v4h-4z"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const SelectIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        {...p}
      >
        <g
          fill="none"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
        >
          <path d="M3 5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2z" />
          <path d="m9 11l3 3l3-3" />
        </g>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const EyeIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-eye"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M12 12m-2 0a2 2 0 1 0 4 0a2 2 0 1 0 -4 0"></path>
        <path d="M22 12c-2.667 4.667 -6 7 -10 7s-7.333 -2.333 -10 -7c2.667 -4.667 6 -7 10 -7s7.333 2.333 10 7"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const EyeOffIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-eye-off"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M10.585 10.587a2 2 0 0 0 2.829 2.828"></path>
        <path d="M16.681 16.673a8.717 8.717 0 0 1 -4.681 1.327c-3.6 0 -6.6 -2 -9 -6c1.272 -2.12 2.712 -3.678 4.32 -4.674m2.86 -1.146a9.055 9.055 0 0 1 1.82 -.18c3.6 0 6.6 2 9 6c-.666 1.11 -1.379 2.067 -2.138 2.87"></path>
        <path d="M3 3l18 18"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const PlusIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-plus"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M12 5l0 14"></path>
        <path d="M5 12l14 0"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const LogoutIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-logout"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M14 8v-2a2 2 0 0 0 -2 -2h-7a2 2 0 0 0 -2 2v12a2 2 0 0 0 2 2h7a2 2 0 0 0 2 -2v-2"></path>
        <path d="M7 12h14l-3 -3m0 6l3 -3"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const SettingsIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-adjustments"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M4 10a2 2 0 1 0 4 0a2 2 0 0 0 -4 0"></path>
        <path d="M6 4v4"></path>
        <path d="M6 12v8"></path>
        <path d="M10 16a2 2 0 1 0 4 0a2 2 0 0 0 -4 0"></path>
        <path d="M12 4v10"></path>
        <path d="M12 18v2"></path>
        <path d="M16 7a2 2 0 1 0 4 0a2 2 0 0 0 -4 0"></path>
        <path d="M18 4v1"></path>
        <path d="M18 9v11"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const CheckIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-check"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M5 12l5 5l10 -10"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const CircleCheckIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-circle-check-filled"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path
          d="M17 3.34a10 10 0 1 1 -14.995 8.984l-.005 -.324l.005 -.324a10 10 0 0 1 14.995 -8.336zm-1.293 5.953a1 1 0 0 0 -1.32 -.083l-.094 .083l-3.293 3.292l-1.293 -1.292l-.094 -.083a1 1 0 0 0 -1.403 1.403l.083 .094l2 2l.094 .083a1 1 0 0 0 1.226 0l.094 -.083l4 -4l.083 -.094a1 1 0 0 0 -.083 -1.32z"
          stroke-width="0"
          fill="currentColor"
        ></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const CircleAlertIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-alert-circle-filled"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path
          d="M12 2c5.523 0 10 4.477 10 10a10 10 0 0 1 -19.995 .324l-.005 -.324l.004 -.28c.148 -5.393 4.566 -9.72 9.996 -9.72zm.01 13l-.127 .007a1 1 0 0 0 0 1.986l.117 .007l.127 -.007a1 1 0 0 0 0 -1.986l-.117 -.007zm-.01 -8a1 1 0 0 0 -.993 .883l-.007 .117v4l.007 .117a1 1 0 0 0 1.986 0l.007 -.117v-4l-.007 -.117a1 1 0 0 0 -.993 -.883z"
          stroke-width="0"
          fill="currentColor"
        ></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const LockIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-lock"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M5 13a2 2 0 0 1 2 -2h10a2 2 0 0 1 2 2v6a2 2 0 0 1 -2 2h-10a2 2 0 0 1 -2 -2v-6z"></path>
        <path d="M11 16a1 1 0 1 0 2 0a1 1 0 0 0 -2 0"></path>
        <path d="M8 11v-4a4 4 0 1 1 8 0v4"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const LockOpenIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-lock-open"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M5 11m0 2a2 2 0 0 1 2 -2h10a2 2 0 0 1 2 2v6a2 2 0 0 1 -2 2h-10a2 2 0 0 1 -2 -2z"></path>
        <path d="M12 16m-1 0a1 1 0 1 0 2 0a1 1 0 1 0 -2 0"></path>
        <path d="M8 11v-5a4 4 0 0 1 8 0"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const FontFamilyIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-typography"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M4 20l3 0"></path>
        <path d="M14 20l7 0"></path>
        <path d="M6.9 15l6.9 0"></path>
        <path d="M10.2 6.3l5.8 13.7"></path>
        <path d="M5 20l6 -16l2 0l7 16"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const TextSizeIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-text-size"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M3 7v-2h13v2"></path>
        <path d="M10 5v14"></path>
        <path d="M12 19h-4"></path>
        <path d="M15 13v-1h6v1"></path>
        <path d="M18 12v7"></path>
        <path d="M17 19h2"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const TextItalicIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-italic"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M11 5l6 0"></path>
        <path d="M7 19l6 0"></path>
        <path d="M14 5l-4 14"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const LetterSpacingIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-letter-spacing"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M5 12v-5.5a2.5 2.5 0 0 1 5 0v5.5m0 -4h-5"></path>
        <path d="M13 4l3 8l3 -8"></path>
        <path d="M5 18h14"></path>
        <path d="M17 20l2 -2l-2 -2"></path>
        <path d="M7 16l-2 2l2 2"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const TextBoldIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-bold"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M7 5h6a3.5 3.5 0 0 1 0 7h-6z"></path>
        <path d="M13 12h1a3.5 3.5 0 0 1 0 7h-7v-7"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const LineHeightIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-line-height"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M3 8l3 -3l3 3"></path>
        <path d="M3 16l3 3l3 -3"></path>
        <path d="M6 5l0 14"></path>
        <path d="M13 6l7 0"></path>
        <path d="M13 12l7 0"></path>
        <path d="M13 18l7 0"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const ArrowsDiagonalIcon: Component<
  JSX.SvgSVGAttributes<SVGSVGElement>
> = function (p) {
  return (
    <svg
      xmlns="http://www.w3.org/2000/svg"
      class="icon icon-tabler icon-tabler-arrows-diagonal"
      width="1.2em"
      height="1.2em"
      viewBox="0 0 24 24"
      stroke-width="2"
      stroke="currentColor"
      fill="none"
      stroke-linecap="round"
      stroke-linejoin="round"
      {...p}
    >
      <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
      <path d="M16 4l4 0l0 4"></path>
      <path d="M14 10l6 -6"></path>
      <path d="M8 20l-4 0l0 -4"></path>
      <path d="M4 20l6 -6"></path>
    </svg>
  );
};

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const ArrowsDiagonalMinimizeIcon: Component<
  JSX.SvgSVGAttributes<SVGSVGElement>
> = function (p) {
  return (
    <svg
      xmlns="http://www.w3.org/2000/svg"
      class="icon icon-tabler icon-tabler-arrows-diagonal-minimize-2"
      width="1.2em"
      height="1.2em"
      viewBox="0 0 24 24"
      stroke-width="2"
      stroke="currentColor"
      fill="none"
      stroke-linecap="round"
      stroke-linejoin="round"
      {...p}
    >
      <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
      <path d="M18 10h-4v-4"></path>
      <path d="M20 4l-6 6"></path>
      <path d="M6 14h4v4"></path>
      <path d="M10 14l-6 6"></path>
    </svg>
  );
};

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const CopyIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-copy"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M8 8m0 2a2 2 0 0 1 2 -2h8a2 2 0 0 1 2 2v8a2 2 0 0 1 -2 2h-8a2 2 0 0 1 -2 -2z"></path>
        <path d="M16 8v-2a2 2 0 0 0 -2 -2h-8a2 2 0 0 0 -2 2v8a2 2 0 0 0 2 2h2"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const ChevronDownIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-chevron-down"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M6 9l6 6l6 -6"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const RefreshIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-refresh"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M20 11a8.1 8.1 0 0 0 -15.5 -2m-.5 -4v4h4"></path>
        <path d="M4 13a8.1 8.1 0 0 0 15.5 2m.5 4v-4h-4"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const TreeIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-list-tree"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M9 6h11"></path>
        <path d="M12 12h8"></path>
        <path d="M15 18h5"></path>
        <path d="M5 6v.01"></path>
        <path d="M8 12v.01"></path>
        <path d="M11 18v.01"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const SelectorIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-selector"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M8 9l4 -4l4 4"></path>
        <path d="M16 15l-4 4l-4 -4"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const FileIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-file"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M14 3v4a1 1 0 0 0 1 1h4"></path>
        <path d="M17 21h-10a2 2 0 0 1 -2 -2v-14a2 2 0 0 1 2 -2h7l5 5v11a2 2 0 0 1 -2 2z"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const ExternalLinkIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-external-link"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M12 6h-6a2 2 0 0 0 -2 2v10a2 2 0 0 0 2 2h10a2 2 0 0 0 2 -2v-6"></path>
        <path d="M11 13l9 -9"></path>
        <path d="M15 4h5v5"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const AsteriskIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-asterisk"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M12 12l8 -4.5"></path>
        <path d="M12 12v9"></path>
        <path d="M12 12l-8 -4.5"></path>
        <path d="M12 12l8 4.5"></path>
        <path d="M12 3v9"></path>
        <path d="M12 12l-8 4.5"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const CancelIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-x"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M18 6l-12 12"></path>
        <path d="M6 6l12 12"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const SunIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-sun"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M12 12m-4 0a4 4 0 1 0 8 0a4 4 0 1 0 -8 0"></path>
        <path d="M3 12h1m8 -9v1m8 8h1m-9 8v1m-6.4 -15.4l.7 .7m12.1 -.7l-.7 .7m0 11.4l.7 .7m-12.1 -.7l-.7 .7"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const MoonIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-moon-stars"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M12 3c.132 0 .263 0 .393 0a7.5 7.5 0 0 0 7.92 12.446a9 9 0 1 1 -8.313 -12.454z"></path>
        <path d="M17 4a2 2 0 0 0 2 2a2 2 0 0 0 -2 2a2 2 0 0 0 -2 -2a2 2 0 0 0 2 -2"></path>
        <path d="M19 11h2m-1 -1v2"></path>
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const SwitchHorizontalIcon: Component<
  JSX.SvgSVGAttributes<SVGSVGElement>
> = function (p) {
  return (
    <svg
      xmlns="http://www.w3.org/2000/svg"
      class="icon icon-tabler icon-tabler-switch-horizontal"
      width="1.2em"
      height="1.2em"
      viewBox="0 0 24 24"
      stroke-width="2"
      stroke="currentColor"
      fill="none"
      stroke-linecap="round"
      stroke-linejoin="round"
      {...p}
    >
      <path stroke="none" d="M0 0h24v24H0z" fill="none" />
      <path d="M16 3l4 4l-4 4" />
      <path d="M10 7l10 0" />
      <path d="M8 13l-4 4l4 4" />
      <path d="M4 17l9 0" />
    </svg>
  );
};

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const LinkIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-link"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none" />
        <path d="M9 15l6 -6" />
        <path d="M11 6l.463 -.536a5 5 0 0 1 7.071 7.072l-.534 .464" />
        <path d="M13 18l-.397 .534a5.068 5.068 0 0 1 -7.127 0a4.972 4.972 0 0 1 0 -7.071l.524 -.463" />
      </svg>
    );
  };

/*
 * License: https://github.com/tabler/tabler-icons/blob/master/LICENSE
 * MIT License
 * Copyright (c) 2020-2023 Paweł Kuna
 */
export const LinkOffIcon: Component<JSX.SvgSVGAttributes<SVGSVGElement>> =
  function (p) {
    return (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="icon icon-tabler icon-tabler-link-off"
        width="1.2em"
        height="1.2em"
        viewBox="0 0 24 24"
        stroke-width="2"
        stroke="currentColor"
        fill="none"
        stroke-linecap="round"
        stroke-linejoin="round"
        {...p}
      >
        <path stroke="none" d="M0 0h24v24H0z" fill="none" />
        <path d="M9 15l3 -3m2 -2l1 -1" />
        <path d="M11 6l.463 -.536a5 5 0 0 1 7.071 7.072l-.534 .464" />
        <path d="M3 3l18 18" />
        <path d="M13 18l-.397 .534a5.068 5.068 0 0 1 -7.127 0a4.972 4.972 0 0 1 0 -7.071l.524 -.463" />
      </svg>
    );
  };
