import { createContext } from "solid-js";
import { SetStoreFunction, Store } from "solid-js/store";
import { EditorUiState } from "../../types";
import type { Settings } from "../../server/settings";

export const EditorUiContext =
  createContext<
    [get: Store<EditorUiState>, set: SetStoreFunction<EditorUiState>]
  >();
export const ElementFocusContext = createContext<(id: string) => void>();
export const SettingsContext = createContext<
  [
    get: Store<{ pages: Partial<Settings>; projects: Partial<Settings> }>,
    set: SetStoreFunction<{
      pages: Partial<Settings>;
      projects: Partial<Settings>;
    }>,
  ]
>();
