import { Component } from "solid-js";
import { A, Outlet } from "solid-start";
import { useAuth, useLogoutAction } from "nitropage";
import { css } from "nitropage/css";
import { SmallButton } from "../common/buttons";
import { Logo, StyleContainer } from "../admin/util";
import { LogoutIcon } from "../common/icons";
import Container from "./container";

const Dashboard: Component = function () {
  const user = useAuth();
  const [__, logoutAction] = useLogoutAction();

  return (
    <StyleContainer>
      <div class={"np-h-screen "}>
        <div class={css({ backgroundColor: "white" })}>
          <Container>
            <div
              class={css({
                display: "flex",
                alignItems: "center",
                gap: "1rem",
                marginTop: "0.5rem",
                marginBottom: "0.5rem",
                "& h1": {
                  fontSize: "1.375rem",
                },
              })}
            >
              <A href="/admin">
                <h1>
                  <Logo />
                </h1>
              </A>
              <div
                class={css({
                  flex: "1",
                  display: "flex",
                  alignItems: "center",
                  gap: "1rem",
                  justifyContent: "flex-end",
                })}
              >
                {user()?.username}
                <SmallButton
                  onClick={async () => {
                    await logoutAction();
                  }}
                >
                  <LogoutIcon /> Logout
                </SmallButton>
              </div>
            </div>
          </Container>
        </div>

        <Outlet />
      </div>
    </StyleContainer>
  );
};

export default Dashboard;
