import { BlueprintDataInput } from "../../../types";
import {
  BlueprintDataInputLayout,
  BlueprintDataTitle,
} from "../../editor/sidebar/blueprintData";
import { Value } from ".";
import { css } from "nitropage/css";
import { NumberInput as NpNumberInput } from "../../common/inputs";
import { Show } from "solid-js";

const NumberInput: BlueprintDataInput<Value> = function (props) {
  const TheInput = function () {
    return (
      <NpNumberInput
        placeholder={props.data.title ? props.data.title() : undefined}
        min={props.data.custom.min}
        max={props.data.custom.max}
        step={props.data.custom.step}
        setValue={(v) => {
          props.setValue(function (draft) {
            draft.content = v;
            return draft;
          });
        }}
        value={props.value?.content != null ? props.value?.content : ""}
      />
    );
  };

  const Header = function () {
    return (
      <BlueprintDataTitle {...props}>
        <Show when={!props.data.custom.wide}>
          <TheInput />
        </Show>
      </BlueprintDataTitle>
    );
  };
  return (
    <BlueprintDataInputLayout header={<Header />}>
      <Show when={props.data.custom.wide}>
        <div
          class={css({
            fontSize: "0.9rem",
            padding: "0.5rem 1rem",
          })}
        >
          <TheInput />
        </div>
      </Show>
    </BlueprintDataInputLayout>
  );
};

export default NumberInput;
