import { lazy } from "solid-js";
import { BlueprintData } from "../../../types";

const id = "@npgjs/text";

export type Value = { content: string };

const getter = function (v?: Value) {
  return v?.content || "";
};

const textData = ({
  title,
  wide,
  multiline,
  sanitizeSlug,
}: {
  title?: BlueprintData["title"];
  wide?: boolean;
  multiline?: boolean;
  sanitizeSlug?: boolean;
} = {}) => {
  return {
    id: id,
    title,
    getter,
    defaultValue: () => ({ content: "" }) as Value,
    input: lazy(async () => import("./input")),
    custom: {
      wide,
      multiline,
      sanitizeSlug,
    },
  } satisfies BlueprintData<Value>;
};

export default textData;
