import { lazy } from "solid-js";
import { BlueprintData } from "../../../types";

const id = "@npgjs/toggle";

export type Value = { content: boolean };

const toggleData = ({
  title,
  defaultValue,
}: {
  title?: BlueprintData["title"];
  defaultValue?: boolean;
} = {}) => {
  const getter = function (v?: Value) {
    return v?.content != null ? v?.content : defaultValue;
  };

  return {
    id: id,
    title,
    getter,
    defaultValue: () => ({ content: defaultValue }) as Value,
    input: lazy(async () => import("./input")),
    custom: {
      defaultValue,
    },
  } satisfies BlueprintData<Value>;
};

export default toggleData;
