import { BlueprintDataInput } from "../../../types";
import {
  BlueprintDataInputLayout,
  BlueprintDataTitle,
} from "../../editor/sidebar/blueprintData";
import { Value } from ".";
import Checkbox from "../../common/checkbox";

const ToggleInput: BlueprintDataInput<Value> = function (props) {
  const TheInput = function () {
    return (
      <Checkbox
        state={
          props.value?.content != null
            ? props.value?.content
            : props.data.custom.defaultValue
        }
        setState={(v) =>
          props.setValue(function (draft) {
            draft.content = v;
            return draft;
          })
        }
      />
    );
  };
  const Header = function () {
    return (
      <BlueprintDataTitle {...props}>
        <TheInput />
      </BlueprintDataTitle>
    );
  };
  return <BlueprintDataInputLayout header={<Header />} />;
};

export default ToggleInput;
