import { FlowComponent, Show, sharedConfig } from "solid-js";
import { NoHydration, isServer } from "solid-js/web";

const NoHydrate: FlowComponent<{ forceHydration?: boolean }> = function (
  props,
) {
  return (
    <Show
      when={
        props.forceHydration != true &&
        !isServer &&
        sharedConfig.context &&
        !import.meta.env.DEV
      }
      fallback={props.children}
    >
      {(_) => {
        return <NoHydration>{props.children}</NoHydration>;
      }}
    </Show>
  );
};

export default NoHydrate;
