import { createRouteData, RouteDataArgs } from "solid-start";

export const createPageData = <
  T extends (args: { urlPath: string }) => Promise<any>,
>(
  routeDataArgs: RouteDataArgs,
  fn: T,
) => {
  const resource = createRouteData(
    function ([urlPath], event) {
      return fn({ urlPath }) as Awaited<ReturnType<T>>;
    },
    { key: () => [routeDataArgs.params.page] },
  );
  // Start loading the auth data as soon as possible
  resource();
  return { page: resource };
};
