import type {
  PrismaClient as ImportedPrismaClient,
  Prisma,
} from "@prisma/client";
import * as mod from "module";

// https://github.com/prisma/prisma/issues/5030#issuecomment-1398076317
export const PrismaClient: {
  new (args: Prisma.PrismaClientOptions): ImportedPrismaClient;
} = (import.meta.env.SSR &&
  (function () {
    const require = (mod as any).createRequire(import.meta.url ?? __filename);
    const { PrismaClient: RequiredPrismaClient } = require("@prisma/client");
    const _PrismaClient: typeof ImportedPrismaClient = RequiredPrismaClient;
    class PrismaClient extends _PrismaClient {}

    return PrismaClient;
  })()) as any;

export const prisma: ImportedPrismaClient = (import.meta.env.SSR &&
  new PrismaClient({
    // Inspired by: https://github.com/t3-oss/create-t3-app/blob/1e4c2d352e9b42e0f48c98980714c5334bfd06d7/cli/template/extras/src/server/db.ts#L12
    log: import.meta.env.DEV ? ["query", "error", "warn"] : ["error"],
  })) as any;
