import bcrypt from "bcrypt";

export const hashPassword = async function (password: string) {
  const saltedPassword = saltPassword(password);
  return await bcrypt.hash(saltedPassword, 10);
};

export const validatePassword = function (content: string, hash: string) {
  return bcrypt.compare(saltPassword(content), hash);
};

export const saltPassword = function (password: string) {
  const saltedPassword = password + `-${process.env["NP_AUTH_SALT"]}`;
  return saltedPassword;
};
