import { rm } from "fs/promises";
import { join } from "path";
import { prisma } from "../prisma";

export const getFontsPath = () => join(process.cwd(), "public", "fonts");

export const deleteFont = async function (id: string) {
  const font = await prisma.nitroFont.findUniqueOrThrow({
    where: {
      id,
    },
  });
  await rm(join(getFontsPath(), font.publicId), {
    recursive: true,
    force: true,
  });
  await prisma.nitroFontFace.deleteMany({
    where: {
      font: {
        id,
      },
    },
  });
  return await prisma.nitroFont.delete({
    where: {
      id,
    },
  });
};
