import { xxh3 } from "@node-rs/xxhash";
import { createHash } from "node:crypto";

// alternative: https://github.com/jungomi/xxhash-wasm
const xxhash = xxh3.Xxh3.withSeed();

export const fastHash = function (content: string) {
  const hash = xxhash.update(content).digest().toString(16);
  xxhash.reset();
  return hash;
};

export const keyHash = function (content: string) {
  const hash = createHash("sha256")
    .update(`${content}-${process.env["NP_PUBLIC_SALT"] || ""}`)
    .digest("base64");
  return hash;
};
