import { createStore } from "solid-js/store";
import { EditorUiState } from "./../types";
import type { Settings } from "../server/settings";

export const createEditorUiState = function (args: {
  pageId: string;
  revisionId: string;
}): EditorUiState {
  const { pageId, revisionId } = args;

  return {
    pageId,
    expandElementsTree: false,
    selectedRevisionId: revisionId,
    sidebarStatus: "idle",
    sidebarIdleTab: "elements",
    sidebarElementsTab: "element",
    toolbarStatus: "write",
    movingElementId: false,
    darkMode: false,
    createMoveTarget: {},
    deletingElementId: undefined,
    creatingElementId: undefined,
    hoveredElementId: undefined,
    selectedElementId: undefined,
    selectedBlueprint: undefined,
  };
};
export const createEditorUiStore = function (args: {
  pageId: string;
  revisionId: string;
}) {
  return createStore(createEditorUiState(args));
};
export const createSettingsStore = function () {
  return createStore<{ pages: Partial<Settings>; projects: Partial<Settings> }>(
    {
      pages: {},
      projects: {},
    },
  );
};
