import { onCleanup } from "solid-js";
import { isServer } from "solid-js/web";

export const spread = function <T extends {}>(objectA: T, objectB: Object): T {
  return Object.assign(objectA, objectB) as any;
};

export const demoEnabled = function () {
  return import.meta.env.VITE_NP_DEMO === "1";
};

export const onClientCleanup = function (fn: () => any) {
  if (isServer) {
    return;
  }

  onCleanup(fn);
};
