import { z } from "zod";

export const PositionSchema = z.string().optional();
export const FitSchema = z
  .union([z.literal("cover"), z.literal("contain")])
  .optional();
export const SizeSchema = z.object({
  width: z.number().optional(),
  height: z.number().optional(),
  quality: z.number().optional(),
  position: PositionSchema,
  fit: FitSchema,
});

export type ImageSize = z.infer<typeof SizeSchema>;
