import clsx from "clsx";
import { createBlueprint, BlueprintComponent } from "nitropage";
import { colorData, colorClass } from "nitropage/data/color";
import { Container } from "~/components/container";

const MyComponent: BlueprintComponent<typeof blueprint> = function (props) {
  return (
    <Container
      class={colorClass(props.data.backgroundColor, "bg")}
      {...props.elementProps}
    >
      {props.handles}
      <props.Slot
        editorPadding={false}
        class={clsx(
          "py-14 lg:py-20 flex flex-col gap-7 lg:gap-8 xl:gap-10",
          !props.lax && "min-h-[50px]",
        )}
        name="default"
      />
    </Container>
  );
};

export const blueprint = createBlueprint(
  () => {
    return {
      title() {
        return "Blog Post Container";
      },
      slots: { default: {} },
      data: {
        backgroundColor: colorData({
          title() {
            return "Background Color";
          },
        }),
      },
    };
  },
  import.meta.hot,
);

export default MyComponent;
export const id = "g26xzngulddq5qqn3ur23w29";
