import clsx from "clsx";
import { createBlueprint, BlueprintComponent } from "nitropage";
import { mediaData, useMedia } from "nitropage/data/media";
import { Show } from "solid-js";

const MyComponent: BlueprintComponent<typeof blueprint> = function (props) {
  const [audio] = useMedia(() => props.data.audio);

  return (
    <div
      class={clsx(
        props.admin && "min-h-[20px]",
        props.admin && !audio().byOrder[0] && "bg-slate-300",
      )}
      {...props.elementProps}
    >
      {props.handles}
      <Show when={audio().byOrder[0]} keyed>
        {(file) => {
          return (
            <audio controls>
              <source src={file.url} type={file.mime} />
            </audio>
          );
        }}
      </Show>
    </div>
  );
};

export const blueprint = createBlueprint(
  () => {
    return {
      acceptParentType: "element",
      data: {
        audio: mediaData({
          max: 1,
          type: "audio",
        }),
      },
    };
  },
  import.meta.hot,
);

export default MyComponent;
export const id = "osq784w5pxym8kh1q9rsj1m4";
