import { FlowComponent, JSX, splitProps } from "solid-js";
import clsx from "clsx";

export const Container: FlowComponent<JSX.HTMLAttributes<HTMLDivElement>> =
  function (props) {
    const [local, rest] = splitProps(props, ["children", "class"]);
    return (
      <div
        class={clsx(local.class, "container mx-auto px-5 md:px-8 lg:px-10")}
        {...rest}
      >
        {local.children}
      </div>
    );
  };
