import { TextField } from "@kobalte/core";
import clsx from "clsx";
import { Component, JSX, splitProps } from "solid-js";

const Input: Component<JSX.InputHTMLAttributes<HTMLInputElement>> = function (
  props,
) {
  const [local, rest] = splitProps(props, ["class"]);
  return (
    <TextField.Root>
      <TextField.Input
        type="text"
        class={clsx(
          local.class,
          "px-4 py-2 text-gray-700 bg-white border rounded-md focus:border-blue-400  focus:outline-none focus:ring focus:ring-opacity-40 focus:ring-blue-300",
        )}
        {...rest}
      />
    </TextField.Root>
  );
};

export default Input;
