// @refresh reload
import { Suspense } from "solid-js";
import {
  Body,
  ErrorBoundary,
  FileRoutes,
  Head,
  Html,
  Meta,
  Routes,
  Scripts,
} from "solid-start";
import { Root as NpRoot } from "nitropage";
import "./root.css";

export default function Root() {
  return (
    <Html class="app" lang="en">
      <Head>
        <Meta charset="utf-8" />
        <Meta name="viewport" content="width=device-width, initial-scale=1" />
        <script>
          {`window.matchMedia('(prefers-color-scheme: dark)').matches && document.documentElement.classList.add('dark');`}
        </script>
      </Head>
      <Body class="overflow-x-hidden">
        <NpRoot>
          <Suspense>
            <ErrorBoundary>
              <Routes>
                <FileRoutes />
              </Routes>
            </ErrorBoundary>
          </Suspense>
          <Scripts />
        </NpRoot>
      </Body>
    </Html>
  );
}
