import solid from "solid-start/vite";
import { defineConfig } from "vite";
import nitropage from "nitropage/vite";
import Icons from "unplugin-icons/vite";
import server from "nitropage/start-handler";

export default defineConfig(({ mode }) => {
  return nitropage({
    server: {
      host: "0.0.0.0",
    },
    publicDir: mode === "production" ? "nope" : undefined,
    optimizeDeps: {
      include: [
        "@solid-primitives/scroll",
        "clsx",
        "highlight.js",
        "motion",
        "solid-transition-group",
        "vidstack",
      ],
    },
    plugins: [
      Icons({ compiler: "solid" }),
      solid({
        adapter: server(),
      }),
    ],
  });
});
